#version 330 core
out vec4 color;
in vec2 TexCoords;
in float avgLuminance;

uniform sampler2D hdrBuffer;
uniform sampler2D logBuffer;
uniform float intensity;

void main()
{
    vec3 hdrColor = texture(hdrBuffer, TexCoords).rgb;
    // reinhard
	float a = 0.18;
	vec3 L_xy = (a * hdrColor) / (avgLuminance);
    vec3 result = L_xy / (L_xy + vec3(1.0));
    color = vec4(result * intensity, 1.0f);
}