#version 330 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec2 texCoords;

uniform sampler2D hdrBuffer;
uniform sampler2D logBuffer;

out vec2 TexCoords;
out float avgLuminance;

void main()
{
    gl_Position = vec4(position, 1.0f);
    TexCoords = texCoords;
	vec2 zeroVec = vec2(0, 0);
	vec2 sizeVec = textureSize(logBuffer, 0);
	float mipmapLevel = 1 + floor(log2(max(sizeVec.x, sizeVec.y)));
	//avgLuminance = texture(logBuffer, TexCoords);//(textureLod(logBuffer, zeroVec, mipmapLevel));
	vec4 lumvec = exp(textureLod(logBuffer, zeroVec, mipmapLevel));
	avgLuminance = dot(lumvec.rgb, vec3(0.2126, 0.7152, 0.0722));
}