#version 330 core
//Light Shader
//VERTEX SHADER

//Input: Die untransformierte Position
in vec3 position;
//Input: Die UV-Koordinaten (Falls Diffus-Textur)
in vec2 uv;
//Input: Normale
in vec3 normal;

//Out: UV
out vec2 fUv;
//Out: Normale
out vec3 fNormal;
//Out: Vector von Oberflche zum Auge
out vec3 fEye;
//Out: Position
out vec3 fPosition;

//Uniform: Model-Matrix
uniform mat4 model;
//Uniform: Inverse Model-Matrix
uniform mat3 transposedInverseModel;
//Uniform: ViewProjection-Matrix
uniform mat4 view_proj;
//Uniform: Kameraposition
uniform vec3 eyePos;

void main() {
	//MVP-Matrix anwenden
	gl_Position = view_proj * model * vec4(position, 1);
	vec4 xPosition = model * vec4(position, 1);
	//Welt-Position (ohne VP-Matrix) an Fragment-Shader weiterreichen
	fPosition = xPosition.xyz / xPosition.w;
	//UV-Koordinaten an Fragment-Shader weiterreichen
	fUv = uv;
	//Transformierte Normale und Richtung zum Auge weitergeben
	fNormal = normalize(transposedInverseModel* normal);			//TODO: Inverse Matrix sollte nicht berechnet, sondern bergeben werden
	fEye = normalize(eyePos - fPosition);
}